<template>
  <v-text-field
    v-bind="$attrs"
    :label="$t('label', { requiredFlag: required ? '*' : '' })"
    :placeholder="$t('placeholder')"
    prepend-icon="mdi-numeric"
    :hint="$t('hint')"
    :rules="rules"
    v-on="$listeners"
  >
    <template v-slot:append-outer>
      <v-tooltip
        bottom
        :color="$vuetify.theme.themes.light.warning"
      >
        <template v-slot:activator="{ on, attrs }">
          <refresh-icon-btn
            v-bind="attrs"
            small
            :disabled="disableRefreshButton"
            v-on="on"
            @click="$emit('onClickRefresh', $event)"
          />
        </template>
        <p class="mb-0 alert d-flex align-content-center">
          <v-icon
            color="white"
            class="mr-1"
          >
            mdi-alert-outline
          </v-icon>
          <span>{{ $t('alert') }}</span>
        </p>
      </v-tooltip>
    </template>
  </v-text-field>
</template>

<script>
  import {
    required,
    integer,
    minValue,
    maxValue,
  } from '@/lib/validators'

  export default {
    name: 'NumberOfInstallmentsTextField',
    props: {
      required: {
        type: Boolean,
        required: false,
        default: false,
      },
      minNumberOfInstallments: {
        type: Number,
        required: false,
        default: 1,
      },
      maxNumberOfInstallments: {
        type: Number,
        required: false,
        default: 85,
      },
      disableRefreshButton: {
        type: Boolean,
        required: false,
        default: false,
      },
    },
    computed: {
      rules () {
        const defaultRules = [
          integer,
          minValue(this.minNumberOfInstallments),
          maxValue(this.maxNumberOfInstallments),
        ]
        return this.required
          ? [required, ...defaultRules]
          : defaultRules
      },
    },
    i18n: {
      messages: {
        'pt-BR': {
          label: 'Número de prestações{requiredFlag}',
          placeholder: 'Informe apenas números.',
          hint: 'Utilize o atualizar para gerar o formulário de prestações automaticamente.',
          alert: 'As prestações serão resetadas e você poderá perder informações.',
        },
        'en-US': {
          label: 'Number of installments{requiredFlag}',
          placeholder: 'Enter only numbers.',
          hint: 'Use the refresh button to generate the installment form automatically.',
          alert: 'Installments will be reset and you may lose information.',
        },
      },
    },
  }
</script>

<style lang="scss" scoped>
  .alert {
    font-size: small;
  }
</style>
